freeslot(
"SKINCOLOR_TENNOJI",
"SKINCOLOR_TENNOJI2",
"SKINCOLOR_SUPERRINA1",
"SKINCOLOR_SUPERRINA2",
"SKINCOLOR_SUPERRINA3",
"SKINCOLOR_SUPERRINA4",
"SKINCOLOR_SUPERRINA5",
"S_RINA_FLY"
)

skincolors[SKINCOLOR_TENNOJI] = {
	name = "Tennoji",
	ramp = {252,200,200,201,201,202,202,203,204,205,206,207,129,132,135,138},
	invcolor = SKINCOLOR_TENNOJI2,
	invshade = 11,
	chatcolor = V_ROSYMAP,
	accessible = false
}

skincolors[SKINCOLOR_TENNOJI2] = {
	name = "Tennoji Alt",
	ramp = {0,252,252,200,200,201,201,202,203,204,205,206,128,131,134,137},
	invcolor = SKINCOLOR_TENNOJI,
	invshade = 11,
	chatcolor = V_ROSYMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPERRINA1] = {
	name = "Super Rina 1",
	ramp = {0,0,0,0,0,252,252,200,200,201,201,202,252,201,202,203},
	accessible = false
}

skincolors[SKINCOLOR_SUPERRINA2] = {
	name = "Super Rina 2",
	ramp = {0,252,200,201,201,201,202,202,202,202,203,204,201,203,204,205},
	accessible = false
}

skincolors[SKINCOLOR_SUPERRINA3] = {
	name = "Super Rina 3",
	ramp = {201,201,201,202,202,202,202,203,203,204,205,206,203,205,206,207},
	accessible = false
}

skincolors[SKINCOLOR_SUPERRINA4] = {
	name = "Super Rina 4",
	ramp = {201,202,202,202,203,203,204,204,205,205,206,207,204,205,206,207},
	accessible = false
}

skincolors[SKINCOLOR_SUPERRINA5] = {
	name = "Super Rina 5",
	ramp = {202,202,203,203,203,204,204,205,205,206,207,207,205,206,207,207},
	accessible = false
}

states[S_RINA_FLY] = {
	sprite = SPR_PLAY,
	frame = SPR2_RUN|FF_ANIMATE,
	tics = -1,
	nextstate = S_PLAY_FALL,
	var1 = 3,
	var2 = 2
}

addHook("ThinkFrame", do
	for p in players.iterate
		if p.mo and p.mo.valid
			if p.mo.skin == "rinatennojis"
				if not p.rinaspeed
					p.rinaspeed = FRACUNIT
				end
				if p.playerstate == PST_LIVE
					if p.powers[pw_super] >= 20
						local var = 50
						
						p.mo.spark = P_SpawnMobjFromMobj( 
							p.mo,
							P_RandomRange(-var, var)*FRACUNIT,
							P_RandomRange(-var, var)*FRACUNIT,
							P_RandomRange(-var, var)*FRACUNIT+FRACUNIT*50,
							MT_BOXSPARKLE
						)
						
						if p.mo.spark and p.mo.spark.valid
							p.mo.spark.momx = p.mo.momx/2
							p.mo.spark.momy = p.mo.momy/2
							p.mo.spark.momz = p.mo.momz/2
							p.mo.spark.colorized = true 
							p.mo.spark.color = p.mo.color
							p.mo.spark.fuse = 12
							p.mo.spark.tics = 6
						end
						
						if p.pflags & PF_SPINDOWN and not (p.pflags & PF_JUMPDOWN) and p.mo.state == S_RINA_FLY
							P_SetObjectMomZ(p.mo, -FRACUNIT, true)
						end
						if p.pflags & PF_JUMPDOWN and not (p.pflags & PF_SPINDOWN) and p.mo.state == S_RINA_FLY
							P_SetObjectMomZ(p.mo, FRACUNIT, true)
						end
						
						if leveltime%10 == 0
							if p.mo.state == S_RINA_FLY
								if not (p.hyper and p.hyper.capable)
									P_GivePlayerRings(p, -1)
								end
							end
							
							if p.speed >= p.mo.scale*70
								if not (p.hyper and p.hyper.capable)
									P_GivePlayerRings(p, -1)
								end
							end
						end
					end
					
					if p.speed >= p.mo.scale*32
						if p.rinaspeed and p.rinaspeed < FRACUNIT*36
							if P_IsObjectOnGround(p.mo)
								if p.powers[pw_super]
									p.rinaspeed = p.rinaspeed + FRACUNIT
								else
									p.rinaspeed = p.rinaspeed + FRACUNIT*(3/2)
									if p.speed >= p.mo.scale*40
										p.rinaspeed = p.rinaspeed + FRACUNIT*5
									end
								end
							else
								p.rinaspeed = p.rinaspeed + FRACUNIT/2
							end
						end
						if P_IsObjectOnGround(p.mo)
							if p.rinaspeed >= FRACUNIT*36
								if not p.rinafast
									S_StartSound(p.mo, sfx_cdfm40)
									p.normalspeed = FRACUNIT*52
									p.fakenormalspeed = FRACUNIT*52
									p.rinafast = true
								end
							end
						end
					else
						p.rinaspeed = FRACUNIT
						if P_IsObjectOnGround(p.mo)
							p.rinafast = false
						end
					end
					
					if not p.powers[pw_super]
						if (p.rinaspeed >= FRACUNIT*36) or p.rinafast
							if leveltime%4 == 0
								if p.mo.color == p.skincolor or p.mo.color == ColorOpposite(p.skincolor)
									p.mo.color = ColorOpposite(p.mo.color)
								end
							end
						else
							if p.mo.color == ColorOpposite(p.skincolor)
								p.mo.color = p.skincolor
							end
						end
					end
					
					if p.rinafast or (p.powers[pw_super] >= 20 and p.speed >= p.mo.scale*8) or (p.pflags & PF_THOKKED)
					
						p.powers[pw_strong] = $ | (STR_ATTACK|STR_BUST|STR_SPIKE|STR_SPRING|STR_GUARD)
						local shield = (p.powers[pw_shield] & SH_NOSTACK)
						
						if leveltime%2 == 0 and (p.rinafast or (p.powers[pw_super] >= 25 and p.speed >= p.mo.scale*8))
							if leveltime%4 == 0 and not (p.pflags & PF_SHIELDABILITY)
								local afti = P_SpawnGhostMobj(p.mo)
								afti.angle = p.drawangle
								afti.tics = 12
								afti.fuse = 12
								afti.colorized = true
								afti.color = p.mo.color
								afti.frame = TR_TRANS10|p.mo.frame
							end
							
							if shield == SH_ELEMENTAL
								P_ElementalFire(p)
							end
						end
						
						if not (p.pflags & PF_THOKKED)
							if P_IsObjectOnGround
								if p.rinafast
									p.normalspeed = p.normalspeed + FRACUNIT/8
									p.fakenormalspeed = p.fakenormalspeed + FRACUNIT/8
									if p.powers[pw_super]
										p.normalspeed = p.normalspeed + FRACUNIT/8
										p.fakenormalspeed = p.fakenormalspeed + FRACUNIT/8
									end
								end
							end
						end
						
						p.thrustfactor = 6
						p.accelstart = 96
						p.acceleration = 28
						if p.powers[pw_super]
							p.thrustfactor = 7
							p.accelstart = 128
							p.acceleration = 40
						end
					else
						p.powers[pw_strong] = $ & ~ (STR_ATTACK|STR_BUST|STR_SPIKE|STR_SPRING|STR_GUARD)
						p.thrustfactor = 5
						p.accelstart = 96
						p.acceleration = 28
						p.normalspeed = FRACUNIT*36
						p.fakenormalspeed = FRACUNIT*36
						if p.powers[pw_super]
							p.thrustfactor = 6
							p.accelstart = 128
							p.acceleration = 40
						end
					end
					
					if not P_IsObjectOnGround(p.mo)
						if not p.powers[pw_super]
							if not p.isxmomentum
								if not p.rinafast
									p.accelstart = 48
									p.accelration = 14
									p.thrustfactor = 6
								end
								
								/*if p.mo.state == S_PLAY_WALK or p.mo.state == S_PLAY_RUN
									p.mo.state = S_PLAY_FALL
								end*/
							end
						end
					end
					
					if p.mo.state == S_PLAY_TWINSPIN or p.mo.state == S_PLAY_ROLL
						local afti = P_SpawnGhostMobj(p.mo)
						p.powers[pw_strong] = $ | (STR_ATTACK|STR_BUST|STR_SPIKE|STR_SPRING|STR_GUARD)
						afti.angle = p.drawangle
						afti.tics = 5
						afti.fuse = 5
						--afti.colorized = true
						--afti.color = SKINCOLOR_SUPERRINA2
						afti.frame = p.mo.frame
						if p.mo.state == S_PLAY_TWINSPIN
							p.drawangle = p.mo.angle
						end
					end
					
					if p.rinafast
						if not p.powers[pw_super]
							if p.panim == PA_RUN
								p.mo.state = S_PLAY_DASH
							end
						end
					end
					if p.panim == PA_DASH
						if not p.rinafast
							if p.speed >= FRACUNIT
								p.mo.state = S_PLAY_WALK
							else
								p.mo.state = S_PLAY_STND
							end
						end
					end
				end
			end
		end
	end
end)

addHook("JumpSpinSpecial", function(p)
	if p.mo and p.valid
		if p.mo.skin == "rinatennojis"
			if p.playerstate == PST_LIVE		
				if p.powers[pw_super]
					if p.mo.state != S_RINA_FLY
						p.mo.state = S_RINA_FLY
						P_SetObjectMomZ(p.mo, FRACUNIT*-6, true)
					end
					return true
				end
				/*if p.pflags & PF_THOKKED or p.pflags & PF_SPINDOWN
					return true
				end
				
				p.mo.state = S_PLAY_FALL
				p.mo.momx = p.mo.momx/5
				p.mo.momy = p.mo.momy/5
				P_SetObjectMomZ(p.mo, FRACUNIT*-20, false)
				
				local shield = (p.powers[pw_shield] & SH_NOSTACK)
				
				if shield == SH_FORCE or shield == SH_FORCEHP
					P_SetObjectMomZ(p.mo, FRACUNIT*-40, false)
				elseif shield == SH_ARMAGEDDON
					P_SetObjectMomZ(p.mo, FRACUNIT*-64, false)
					P_BlackOw(p)
				end
				
				p.pflags = $ | PF_THOKKED|PF_SHIELDABILITY*/
			end
		end
	end
end)

addHook("AbilitySpecial", function(p)
	if p.mo and p.valid
		if p.mo.skin == "rinatennojis"
			if p.playerstate == PST_LIVE
				if p.powers[pw_super]
					if p.mo.state != S_RINA_FLY
						p.mo.state = S_RINA_FLY
						P_SetObjectMomZ(p.mo, FRACUNIT*6, true)
					end
					return true
				end
				
				if P_GetPlayerControlDirection(p)
					if not (p.pflags & PF_THOKKED)
						P_Thrust(p.mo, p.mo.angle, p.normalspeed/3)
						p.drawangle = p.mo.angle
					end
				end
				
				/*if p.pflags & PF_THOKKED or p.pflags & PF_JUMPDOWN or p.powers[pw_super]
					return true
				end
				
				/*p.mo.state = S_PLAY_ROLL
				dashangle = p.mo.angle
				dashspeed = p.speed + FRACUNIT*24
				P_InstaThrust(p.mo, dashangle, dashspeed)
				P_SetObjectMomZ(p.mo, FRACUNIT*0, false)
				
				airdash = 10
				p.pflags = $ | PF_THOKKED|PF_SHIELDABILITY*/
			end
		end
	end
end)

addHook("MobjDamage", function(t, i, s, d, dt)
	if i and i.player and i.player.valid
		if i.skin == "rinatennojis"
			if i.player.playerstate == PST_LIVE
				i.player.pflags = $ & ~ PF_THOKKED
			end
		end
	end
end)

/*addHook("MobjMoveBlocked", function(m, t, l)
	if m and m.player and m.player.valid
		if m.skin == "rinatennojis"
			if m.player.playerstate == PST_LIVE
				if m.player.rinafast
					if m.player.speed >= FRACUNIT*64
						if t
							P_DoPlayerPain(m.player, t)
						else
							P_DoPlayerPain(m.player)
						end
						m.player.rinaspeed = false
						S_StartSound(m, sfx_s3k5d)
					end
				end
			end
		end
	end
end, MT_PLAYER)*/

/*addHook("MobjMoveCollide", function(p, t)
	if p and p.player and p.player.valid
		if p.skin == "rinatennojis"
			if p.player.playerstate == PST_LIVE
				if p.player.speed >= FRACUNIT*34
					if t.flags & MF_SCENERY
						if not ((t.z > p.z+p.momz+p.height+2<<16) or (t.z+t.height+2<<16 < p.z+p.momz))
							if not t.rcollide
								t.momx = p.momx
								t.momy = p.momy
								P_SetObjectMomZ(t, FRACUNIT*7, true)
								t.flags = $ | MF_NOCLIP|MF_NOCLIPHEIGHT
								t.fuse = 175
								S_StartSound(t, 148)
								t.rollangle = FixedAngle(FRACUNIT*(P_RandomRange(-15, 15)))
								t.rcollide = true
							end
						end
					end
				end
			end
		end
	end
end, MT_PLAYER)*/